import { EventEmitter } from "events";
export interface WSReqonetOptions {
    /** # attempts to reconnect */
    maxRetryAttempts?: number;
    /** Whether to store 'send' data when connection is broken  */
    queueMessage?: boolean;
    /** whether to disable reconnection */
    disableReconnect?: boolean;
    /** enable to get console.log output */
    debug?: boolean;
}
export default class WSReqonet extends EventEmitter {
    private protocols;
    private ws;
    private retryAttempts;
    private maxRetryAttempts;
    private queueMessage;
    private messageQueue;
    private reconnectAttempts;
    private intervalRef;
    private forcedClose;
    private disableReconnect;
    constructor(url: string | URL, protocols?: string | string[], options?: WSReqonetOptions);
    private onopen;
    private onmessage;
    private onError;
    private onclose;
    send: WebSocket["send"];
    close: WebSocket["close"];
    private connect;
    /** relay messages that were queued while the connection was closed */
    private relayQueuedMessages;
    private reconnect;
    private onrestore;
    isopen: () => boolean;
}
